/* (c) Peter Mueller 2010 */
/* Command line options: -Trace -p ssc -l cx -o light automatic_light.xml   */
/* This file is generated from light.h - do not edit manually*/
/* Generated on: Mon Oct 25 19:43:10 CEST 2010 / version 2.1.3 */


#ifndef __LIGHT_H__
#define __LIGHT_H__
/* State definitions */
typedef enum{
	OffManual,
	OnManual,
	AutoAwaitTwilight,
	AutoPrepareOff,
	AutoLightOn,
	AutoMode,
	AutoLightOff
} LIGHT_STATES_T;




/* Predefined types required by the codegen. You can provide your own  */
/* definitions by setting the following define somewhere in your built env. */
#ifndef __PROVIDE_OWN_LIGHT_STATEMACHINE_TYPES__
	typedef unsigned char LIGHT_ENTRY_FLAG_T;
	typedef LIGHT_STATES_T LIGHT_STATEVAR_T;
	typedef unsigned char LIGHT_INST_ID_T;
	typedef unsigned char LIGHT_EV_CONSUMED_FLAG_T;
#endif




/* Instance data definition of state machine */
typedef struct{
	LIGHT_ENTRY_FLAG_T offmanualEntry;
	LIGHT_STATEVAR_T stateVar;
	LIGHT_STATEVAR_T stateVarAutoMode;
	LIGHT_INST_ID_T inst_id;
} LIGHT_INSTANCEDATA_T;

/* Helper to initialize the machine's instance data */
#define LIGHT_INSTANCEDATA_INIT {\
	1,\
	(LIGHT_STATEVAR_T) OffManual /* set init state of top state */,\
	(LIGHT_STATEVAR_T) AutoLightOff /* set init state of AutoMode */,\
	0 /* instance id */ } 

/* Helper(s) to reset history */
#define LIGHT_RESET_HISTORY_AUTOMODE(instance) ((&instance)->stateVarAutoMode=AutoLightOff)

/*Prototypes for the change state function*/
void  lightChangeToState(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_STATES_T state);
void  lightChangeToStateAutoMode(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_STATES_T state);

/*Prototype of the state machine function */
void   light(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_EVENT_T msg);


/* Macros to test if the machine is in a certain state. */
#define LIGHT_IS_IN_OFFMANUAL(instance)((((&instance)->stateVar==OffManual)) ? (1U) : (0U))
#define LIGHT_IS_IN_ONMANUAL(instance)((((&instance)->stateVar==OnManual)) ? (1U) : (0U))
#define LIGHT_IS_IN_AUTOAWAITTWILIGHT(instance)((((&instance)->stateVarAutoMode==AutoAwaitTwilight)&&((&instance)->stateVar==AutoMode)) ? (1U) : (0U))
#define LIGHT_IS_IN_AUTOPREPAREOFF(instance)((((&instance)->stateVarAutoMode==AutoPrepareOff)&&((&instance)->stateVar==AutoMode)) ? (1U) : (0U))
#define LIGHT_IS_IN_AUTOLIGHTON(instance)((((&instance)->stateVarAutoMode==AutoLightOn)&&((&instance)->stateVar==AutoMode)) ? (1U) : (0U))
#define LIGHT_IS_IN_AUTOMODE(instance)((((&instance)->stateVar==AutoMode)) ? (1U) : (0U))
#define LIGHT_IS_IN_AUTOLIGHTOFF(instance)((((&instance)->stateVarAutoMode==AutoLightOff)&&((&instance)->stateVar==AutoMode)) ? (1U) : (0U))

#endif
