#include <stdio.h>
#include "light_ext.h"
#include "light.h"
#include "light_hlp.h"
#include "light_dbg.h"
#include "gui.h"
#include <sys/time.h>

// for UDP based trace function. Only needed if trace is enabled.
void initUdpTrace();

// needed for timing
static struct timespec tv={0,1000*1000*100}; // ~100ms

// instance var of state machine
LIGHT_INSTANCEDATA_T instData = LIGHT_INSTANCEDATA_INIT;

// variable holds switch state
SWITCH_MODE_T modeSwitch=MODE_OFF;

// The next two functions are called from the state machine if the "external change state functions"
// option is set to yes in the config file. This allows to display the active state
// each time the state changes.
void  lightChangeToState(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_STATES_T state){
	printf("NewState = %s\n",lightGetNameByState(state));
	instanceVar->stateVar = state;
}

void  lightChangeToStateAutoMode(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_STATES_T state){
	printf("NewState = %s\n",lightGetNameByState(state));
	instanceVar->stateVarAutoMode = state;
}



// Main function which initializes the keyboard and calles the state machine
// function every ~100ms
//
int main(int argc, char* argv[]){

	// message to state machine
	LIGHT_EVENT_T msg;

	initUdpTrace();
	init_keyboard();
	printf("Usage: Use + to indicate a person\n");
	printf("       Use - to indicate no person\n");
	printf("       Use d to set evnironment to dawn\n");
	printf("       Use t to set environment to twilight\n");
	printf("       Use a to set auto mode\n");
	printf("       Use o to set On mode\n");
	printf("       Use x to set Off mode\n");
	printf("------------------------------\n");		
	
	while(1){
		char ch;
		msg=LIGHT_NO_MSG;
		if(kbhit()){
			ch=readch();
			if(ch=='+')
				msg=evThermalFB;
			else if(ch=='-')
				msg=evNoThermalFB;
			else if(ch=='d')
				msg=evDawn;
			else if(ch=='t')
				msg=evTwilight;
			else if(ch=='a')
				modeSwitch=MODE_AUTO;
			else if(ch=='o')
				modeSwitch=MODE_ON;
			else if(ch=='x')
				modeSwitch=MODE_OFF;
			else if(ch=='r')
				sendReset();
			else if(ch=='q'){
				close_keyboard();
				exit(0);
			}
				
		
			printf("Got: %c\n",ch);
		}
	
		light(&instData,msg);
		nanosleep(&tv,0);
	}

	return 0;
}

